<?php

class Emulator extends Module
{
  var $Id;
  var $Emulator;
  
  function __construct($Database, $Id)
  {
    $this->Database = $Database;
    $this->Id = $Id;
    $DbResult = $this->Database->query('SELECT * FROM `Emulator` WHERE `Id`='.$Id);
    $this->Emulator = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT * FROM `ClientVersion` WHERE `Id`='.$this->Emulator['ClientVersion']);
    $this->Emulator['ClientVersion'] = $DbResult->fetch_assoc();
  }
  
  function AddTask($Title, $Task)
  {
    global $System;
    
    $this->Database->insert('Task', array('User' => $System->Modules['User']->User['Id'], 'Title' => $Title, 'Time' => 'NOW()', 'CommandList' => implode("\n", $Task)));
  }
  
  function Add()
  {
    $EmulatorDir = '../emulator/'.$this->Id.'/';
    if(!file_exists($EmulatorDir)) mkdir($EmulatorDir, 0777, true);    
    
    //$this->AddTask('Vytvoření nového emulátoru', array(
    //  'ln -s wowclient/'.$this->Emulator['ClientVersion']['Version'].'/maps emulator/'.$this->Emulator['Id'].'/mangos/maps',
    //  'ln -s wowclient/'.$this->Emulator['ClientVersion']['Version'].'/dbc emulator/'.$this->Emulator['Id'].'/mangos/dbc',
    //));
    $this->Download();
    $this->Compile();
  }
  
  function GetList()
  {
  }
  
  function Download()
  {
    global $Config;
    
    $this->AddTask('Stažení emulátoru', array(
      'cd '.$Config['BaseDir'].'emulator/'.$this->Id.'/',
      'git clone git://github.com/mangos/mangos.git source',
      'cd source',
      'git checkout '.$this->Emulator['CommitHash'],
      'mkdir src/bindings/ScriptDev2',
      'svn checkout -r '.$this->Emulator['ScriptDev2Revision'].' https://scriptdev2.svn.sourceforge.net/svnroot/scriptdev2/ src/bindings/ScriptDev2',
      'git apply src/bindings/ScriptDev2/patches/'.$this->Emulator['ScriptDev2PatchFileName'],
    ));
  }
  
  function Compile()
  {
    global $Config;
    
    $this->AddTask('Překlad emulátoru', array(
      'cd '.$Config['BaseDir'].'emulator/'.$this->Id.'/source',
      'autoreconf -ifv',
      'mkdir objdir',
      'cd objdir',
      '../configure --prefix='.$Config['BaseDir'].'emulator/'.$this->Id.'/ --enable-cli --enable-ra',
      'make',
      'make install',
    ));
  }
}

?>
